package cn.com.qmth.examcloud.core.basic.service.impl;

import java.util.List;
import java.util.Set;

import javax.transaction.Transactional;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.common.collect.Lists;

import cn.com.qmth.examcloud.core.basic.dao.OrgRepo;
import cn.com.qmth.examcloud.core.basic.dao.PrivilegeRepo;
import cn.com.qmth.examcloud.core.basic.dao.RolePrivilegeRelationRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.RolePrivilegeRelation;
import cn.com.qmth.examcloud.core.basic.service.RolePrivilegeService;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年6月14日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
@Transactional
public class RolePrivilegeServiceImpl implements RolePrivilegeService {

	@Autowired
	PrivilegeRepo privilegeRepo;

	@Autowired
	OrgRepo orgRepo;

	@Autowired
	RolePrivilegeRelationRepo rolePrivilegeRelationRepo;

	@Autowired
	RolePrivilegeService rolePrivilegeService;

	@Override
	public void updateRolePrivilegeRelations(Long rootOrgId, Long roleId,
			Set<Long> privilegeIdSet) {

		rolePrivilegeRelationRepo.deleteByRoleIdAndRootOrgId(roleId, rootOrgId);

		if (CollectionUtils.isEmpty(privilegeIdSet)) {
			return;
		}

		List<RolePrivilegeRelation> list = Lists.newArrayList();
		for (Long cur : privilegeIdSet) {
			RolePrivilegeRelation bean = new RolePrivilegeRelation();
			bean.setRoleId(roleId);
			bean.setRootOrgId(rootOrgId);
			bean.setPrivilegeId(cur);

			list.add(bean);
		}

		rolePrivilegeRelationRepo.save(list);
	}

}
